﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SSS
{
    /// <summary>
    /// Логика взаимодействия для Page3SS.xaml
    /// </summary>
    public partial class Page3SS : Page
    {
       

        private void AddCat_Click(object sender, RoutedEventArgs e)
        {

        }
        public Page3SS()
        {
            InitializeComponent();
            Client.ItemsSource = ClassBaz.BaseConnect.Client.ToList();  // передаем записи из таблицы БД ListView
            List<CarBrand> breedList = ClassBaz.BaseConnect.CarBrand.ToList();

            // программное заполнение выпадающего списка
            CBFilterBreed.Items.Add("Все марки машин");  // первый элемент выпадающего списка, который сбрасывает фильтрацию
            foreach (CarBrand breed in breedList)  // цикл для записи в выпадающий список всех пород котов из БД
            {
                CBFilterBreed.Items.Add(breed.CarBrand1);  // выбранное по умолчанию значение в списке с породами котов ("Все породы")
            }
            CBFilterBreed.SelectedIndex = 0;

        }

        void Filter()  // метод для одновременной фильтрации, поиска и сортировки
        {
            List<Client> catFilter = new List<Client>();  // пустой список, который далее будет заполнять элементами, удавлетворяющими условиям фильтрации, поиска и сортировки

            string breed = CBFilterBreed.SelectedValue.ToString();  // выбранное пользователем название породы

            // поиск совпадений по именам котов
            if (!string.IsNullOrWhiteSpace(TBSearch.Text))  // если строка не пустая и если она не состоит из пробелов
            {
                catFilter = catFilter.Where(x => x.Name.ToLower().Contains(TBSearch.Text.ToLower())).ToList();
            }

            // выбор только котов-мальчиков
            if (CBOnly.IsChecked == true)
            {
                catFilter = catFilter.Where(x => x.id_Gender == 1).ToList();
            }

            // сортировка
            if (RBUp.IsChecked == true)  // позрастанию имени
            {
                catFilter.Sort((x, y) => x.Name.CompareTo(y.Name));
            }
            if (RBDown.IsChecked == true) // по убыванию имени
            {
                catFilter.Sort((x, y) => x.Name.CompareTo(y.Name));
                catFilter.Reverse();
            }
            Client.ItemsSource = catFilter;
        }
        

       

   

        private void Button_Click_1(object sender, RoutedEventArgs e) // удаление кота
        {
            Button tb = (Button)sender;  // получаем доступ к TextBlock из шаблона
            int index = Convert.ToInt32(tb.Uid);  // получаем числовой Uid элемента списка (в разметке предварительно нужно связать номер ячейки с номером кота в базе данных)
            Client catRemove = ClassBaz.BaseConnect.Client.FirstOrDefault(x => x.id_Client == index);
            switch (MessageBox.Show("Удалить кота???", "RemoveCat", MessageBoxButton.YesNo, MessageBoxImage.Question))
            {
                case MessageBoxResult.Yes:
                    ClassBaz.BaseConnect.Client.Remove(catRemove);
                    MessageBox.Show("Кот удален");
                    ClassBaz.BaseConnect.SaveChanges();
                    break;
                case MessageBoxResult.No:
                    MessageBox.Show("Кот не удален");
                    break;
            }

        }

        // далее во всех обработчиках событий применяем один и тот же метод Filter, который позволяет находить условия, удовлетворяющие всем сразу выбранным параметрам
        private void TBSearch_TextChanged(object sender, TextChangedEventArgs e)
        {
            Filter();
        }

        private void CBFilterBreed_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Filter();
        }

        private void CBOnly_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void CBOnly_Unchecked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        private void RBUp_Checked(object sender, RoutedEventArgs e)
        {
            Filter();
        }

        
    }
}

